#!/usr/bin/python
import httplib
import json
import os
import sys, getopt
import requests


# Function: print help
def gettenant_print_help():
  print "[Help] gettenant -p <powervcURL> -u <login> -P <password>"
  print "[Help] Example: ./gettenant -p localhost -u root -P <PASSWORD>"
  sys.exit(0)

# Authentication to get the token
powervcURL = "10.3.25.201"
login = "root"
password = "ibm44sap"

                # JSON for the authentication - user and password replaced later in the code
tokenRequestTemplate = json.dumps(
                {
                        "auth": {
                                "identity": {
                                        "methods": [
                                                "password"
                                        ],
                                        "password": {
                                                "user": {
                                                        "domain": {
                                                                "name": "Default"
                                                        },
                                                        "name": "%(user)s",
                                                        "password": "%(password)s"
                                                }
                                        }
                                },
                                "scope": {
                                        "project": {
                                                "domain": {
                                                        "name": "Default"
                                                },
                                                "name": "ibm-default"
                                        }
                                }
                        }
                })

print "This is the template :", tokenRequestTemplate
Template = json.loads(tokenRequestTemplate)
print Template
# gets an authentication token from keystone
request = requests.post('https://%s:5000/v3/auth/tokens' % powervcURL,
                headers = {'accept': 'application/json',
                'content-type': 'application/json'},
                data = tokenRequestTemplate % {'user': login, 'password': password},
                verify = False)


                # checks if the return code is 201 "created" or raise exception with HTTP return code
if request.status_code == requests.codes.created:
                        token = request.headers['x-subject-token']
                        #catalog = json.loads(request.text)['token']['catalog']
                        #Thecatalog = json.loads(request.text)['token'] 
                        #print "catalog:", catalog

mycatalog = json.loads(request.text)['token']['catalog']
for entry in mycatalog:
    if entry["type"] == 'compute':
        for endpoint in entry['endpoints']:
            if endpoint['interface'] == 'public':
                nova_url = endpoint['url']
                print "public nova_url:", nova_url

for entry in mycatalog:
    if entry["type"] == 'service':
        for endpoint in entry['endpoints']:
            if endpoint['interface'] == 'public':
                _url = endpoint['url']
                print "public url:", _url

# gets the tenant 
print "PowerVC token used = "+token
conn = httplib.HTTPSConnection(powervcURL)
headers = {"X-Auth-Token":token, "Content-type":"application/json"}
body = ""

conn.request("GET", "/powervc/openstack/identity/v3/projects", body, headers)
response = conn.getresponse()
raw_response = response.read()
conn.close()
#print "This is the raw response:", raw_response
json_data = json.loads(raw_response)
#print "This is the raw response json loaded:", json_data
tenant_id=json_data["projects"][1]["id"]
print "This is the tenant id:", tenant_id
#print json.dumps(json_data, indent=4, sort_keys=True)

conn.request("GET", "/home")
response = conn.getresponse()
raw_response = response.read()
#print "This is the raw response:", raw_response





def main():
  try:
    opts, args=getopt.getopt(sys.argv,"p:P:u:")
  except getopt.GetoptError as err:
    print 'gettenant -p <powervc ip@> .....'
    print str(err)
    sys.exit(2)
  for opt, arg in opts:
    if opt in ("-h", "--help"):
      gettenant_print_help()
    elif opt in ("-p"):
      powervc_url=arg
    elif opt in ("-P"):
      password=arg
    elif opt in ("-u"):
      user=arg


if __name__ == "__main__":
  #main(sys.argv[:1])
  main()
